<?php

namespace Schaffen\Core\Company\Models;

use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Company\Traits\HasBranch;

class BranchUser extends Model
{
    use HasBranch;

    protected $prefix = 'usf';
    protected $connection = 'dynamicdb';
    protected $table = 'acesso.usuario_filial';
    protected $primaryKey = "mod_codigo";
    protected $fillable = [
        "usf_codigo",
        "usf_fk_usu_codigo",
        "usf_fk_fil_codigo"
    ];
    const CREATED_AT = "usf_date_insert";
    const CREATED_BY = "usf_user_insert";
    const UPDATED_AT = "usf_date_update";
    const UPDATED_BY = "usf_user_update";



    public function branch() {
        return $this->hasOne(Branch::class, 'usf_fk_fil_codigo', 'fil_codigo');
    }
}
