<?php


namespace Schaffen\Core\Form\Managers;


use Freelabois\LaravelQuickstart\Extendables\ManipulationManager;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Request;
use Schaffen\Core\Form\Repositories\FormRepository;
use Schaffen\Core\Form\Services\ManipulateForm;

class FormManager extends ManipulationManager
{
   public function __construct(FormRepository $repository)
   {
      parent::__construct($repository);
   }

   public function storeOrUpdate($values, int $id = null, $relations = [])
   {
      DB::transaction(function () use ($values, $id, $relations){
         $form = parent::storeOrUpdate($values, $id, $relations);
         if(isset($values['campos']) && count($values['campos']) > 0){
            $manipulate_form = new ManipulateForm();
            $fields = $manipulate_form->getFieldsId($values['campos']);
            if($fields){
               $manipulate_form->sync($form, $fields);
            }
         }
         return $form;
      });
   }
}
