<?php
/**
 * Created for Schaffen IT.
 * User: Thiago Traczykowski
 */

namespace Schaffen\Core\Product\Scopes;


use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Scope;
use Illuminate\Support\Facades\DB;

class ProductName implements Scope
{

   public function apply(Builder $builder, Model $model)
   {

      $field = "pro_descricao||' - '||prv_descricao||' - '||unm_descricao";
      $field .= " || case when trim(pve_codigo_barras) <> '' then ' - ('||pve_codigo_barras||')' else '' end";
      $field .= " || case when mar_codigo <> '-1' then' - '||mar_descricao||'' else '' end";
      return $builder->with(['product_variety_pack' => function ($query) use ($field) {
         $query->select(["produto.produto_variedade_embalagem.*", DB::raw("($field) as product_complete_name")]);
         $query->join('produto.produto_variedade', function ($q) {
            return $q->on('pve_fk_prv_codigo', 'prv_codigo');
         });
         $query->join('produto.produto', function ($q) {
            return $q->on('pro_codigo', 'prv_fk_pro_codigo');
         });
         $query->join('cadastro.unidade_medida', function ($q) {
            return $q->on('unm_codigo', 'pve_fk_unm_codigo');
         });
         $query->join('produto.marca', function ($q) {
            return $q->on('mar_codigo', 'pro_fk_mar_codigo');
         });
         return $query;
      }]);
   }
}
