<?php


namespace Schaffen\Core\Visitation\Repository;


use Freelabois\LaravelQuickstart\Extendables\Repository;
use Schaffen\Core\Visitation\Models\VisitationReason;

class VisitationReasonRepository extends Repository
{
    protected $model = VisitationReason::class;

    protected $searchableFields = [
        ["field" => "mov_descricao", 'operator' => 'ilike'],
        ["field" => "mov_status"],
    ];

    public function dd(array $filters = [], array $with = [], $pagination = 45)
    {
        $this->applyFilters($filters);
        $query = $this->newQuery();
        $query->with($with);
        if ($pagination === "false" || $pagination === false) {
            $pagination = 9223372036854775807;
        }
        if (!empty($this->filters)) {
            dump($this->filters);
            $this->applyCustomFilters();
            $this->injectFiltersOnQuery();
        }
        $this->group();
        $this->order();
        $query->dd();
    }

    public function destroy(int $id): int
    {
        $mv = $this->find($id);
        $mv->mov_status = 0;
        $mv->save();
        return true; // TODO: Change the autogenerated stub
    }

    protected function applyCustomFilters()
    {
        $has_form = null;

        extract($this->filters);

        $this->query->when(isset($has_form), function ($query) use ($has_form){
            if(is_bool($has_form) ? $has_form : $has_form == "true"){
                $query->whereHas('forms');
            }else{
                $query->whereDoesntHave('forms');
            }
            return $query;
        });
    }
}